{-# OPTIONS_GHC -fglasgow-exts #-}

module CetaVerifier where {

import List;
import Xml;
import Eithera;
import ErrorMonad;
import HOL;
import Show;
import Term;
import SemanticLabeling;
import Nat;
import ProofChecker;

data CertificationResult = CertifiedYes | CertifiedNo | Error [Char];

eqWhiteSpace :: [Char] -> [Char] -> Bool;
eqWhiteSpace s1 s2 =
  filtera (\ c -> not (member c wspace)) s1 ==
    filtera (\ c -> not (member c wspace)) s2;

certifyProof :: [Char] -> [Char] -> CertificationResult;
certifyProof trsString prfString =
  (case bind (parseXTCProblem trsString)
          (\ xtcProblem ->
            let {
              parsedTrsString = sshow_xtcProblem xtcProblem;
            } in bind (checkB (eqWhiteSpace trsString parsedTrsString)
                        (concata
                          [['t', 'h', 'e', ' ', 'p', 'a', 'r', 's', 'e', 'd',
                             ' ', 'T', 'R', 'S', ' ', 'd', 'o', 'e', 's', ' ',
                             'n', 'o', 't', ' ', 'c', 'o', 'r', 'r', 'e', 's',
                             'p', 'o', 'n', 'd', ' ', 't', 'o', ' ', 't', 'h',
                             'e', ' ', 'i', 'n', 'p', 'u', 't', ' ', 'T', 'R',
                             'S'],
                            newline, parsedTrsString]))
                   (\ x ->
                     let {
                       (XTCProblem xtcR metaInf) = xtcProblem;
                       (Xtctrs r sig comment) = xtcR;
                     } in bind (parseProof prfString)
                            (\ a ->
                              (case a of {
                                Lefta termPrf ->
                                  (case checkTRSProof ['1'] r termPrf of {
                                    Lefta err -> errora (showLista err);
                                    Righta xa -> returna True;
                                  });
                                Righta nontermPrf ->
                                  (case checkTRSDisproof ['1'] r nontermPrf of {
                                    Lefta err -> errora (showLista err);
                                    Righta xa -> returna False;
                                  });
                              }))))
    of {
    Lefta a -> Error a;
    Righta b -> (if b then CertifiedYes else CertifiedNo);
  });

}
