{-# OPTIONS_GHC -fglasgow-exts #-}

module PolyOrder where {

import qualified List;
import qualified Polynomial;
import qualified Nat;
import qualified Show;
import qualified Option;
import qualified Util;
import qualified Term;
import qualified ErrorMonad;
import qualified Product_Type;
import qualified RedPair;
import qualified UsableRules;
import qualified Eithera;
import qualified HOL;

pleftI ::
  forall a b c.
    (Eq a,
      Eq c) => a -> a -> (a -> a -> a) ->
                           (a -> a -> a) ->
                             (a -> a) ->
                               (b -> Nat.Nat -> (a, [a])) ->
                                 Term.Term b c -> Polynomial.L_poly c a;
pleftI ze on pl ti mz pia (Term.Var x) = Polynomial.LPoly ze [(x, on)];
pleftI ze on pl ti mz pia (Term.Fun f ts) =
  let {
    a = pia f (List.size_list ts);
    (c, asa) = a;
    (Polynomial.LPoly d aa) =
      Polynomial.sum_lpolyI ze pl (Polynomial.LPoly c [])
        (Polynomial.list_sumI (Polynomial.LPoly ze [])
          (Polynomial.sum_lpolyI ze pl)
          (List.mapa
            (\ at ->
              Polynomial.mul_lpolyI ze ti (fst at)
                (PolyOrder.pleftI ze on pl ti mz pia (snd at)))
            (List.zipa asa ts)));
  } in (case aa of {
         [] -> Polynomial.LPoly (mz d) [];
         ab : lista -> Polynomial.LPoly d (ab : lista);
       });

prightI ::
  forall a b c.
    (Eq a,
      Eq c) => a -> a -> (a -> a -> a) ->
                           (a -> a -> a) ->
                             (a -> a) ->
                               (b -> Nat.Nat -> (a, [a])) ->
                                 Term.Term b c -> Polynomial.L_poly c a;
prightI ze on pl ti mz pia (Term.Var x) = Polynomial.LPoly ze [(x, on)];
prightI ze on pl ti mz pia (Term.Fun f ts) =
  let {
    a = pia f (List.size_list ts);
    (c, asa) = a;
    (Polynomial.LPoly d aa) =
      Polynomial.sum_lpolyI ze pl (Polynomial.LPoly c [])
        (Polynomial.list_sumI (Polynomial.LPoly ze [])
          (Polynomial.sum_lpolyI ze pl)
          (List.mapa
            (\ at ->
              Polynomial.mul_lpolyI ze ti (fst at)
                (PolyOrder.prightI ze on pl ti mz pia (snd at)))
            (List.zipa asa ts)));
  } in Polynomial.LPoly (mz d) aa;

create_afI ::
  forall a b.
    (Eq a,
      Eq b) => a -> [((b, Nat.Nat), (a, [a]))] ->
                      b -> Nat.Nat -> Nat.Nat -> Bool;
create_afI ze [] f n i = True;
create_afI ze (((g, m), (c, coeffs)) : rest) f n i =
  (if f == g && m == n
    then Nat.less_nat i (List.size_list coeffs) && not (List.nth coeffs i == ze)
    else PolyOrder.create_afI ze rest f n i);

get_comp_0 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a;
get_comp_0 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = ze;

get_comp_1 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a;
get_comp_1 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = on;

get_comp_ge ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> a -> Bool;
get_comp_ge (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = ge;

get_comp_gt ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> a -> Bool;
get_comp_gt (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = gt;

check_polo_sI ::
  forall a b c.
    (Eq a, Show.Sshow a, Show.Sshow b, Eq c,
      Show.Sshow c) => Bool ->
                         a -> a -> (a -> a -> a) ->
                                     (a -> a -> a) ->
                                       (a -> a) ->
 (a -> a -> Bool) ->
   (a -> a -> Bool) ->
     (b -> Nat.Nat -> (a, [a])) ->
       (Term.Term b c, Term.Term b c) -> Eithera.Eithera [[Char]] ();
check_polo_sI mode ze on pl ti mz ge gt pia (s, t) =
  let {
    left = PolyOrder.pleftI ze on pl ti mz pia s;
    right = PolyOrder.prightI ze on pl ti mz pia t;
  } in ErrorMonad.catcha (Polynomial.check_lpoly_sI mode ze on ge gt left right)
         (\ x ->
           ErrorMonad.errora
             (List.append
                (List.append
                  (List.append
                    ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                      's', 'u', 'r', 'e', ' ']
                    (Show.sshow_list x))
                  [' ', '>', ' '])
                (Term.sshow_term t)
               : x));

get_comp_max0 ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> a;
get_comp_max0 (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = mz;

get_comp_mono ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> Bool;
get_comp_mono (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = mo;

get_comp_plus ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> a -> a;
get_comp_plus (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = pl;

check_polo_nsI ::
  forall a b c.
    (Eq a, Show.Sshow a, Show.Sshow b, Eq c,
      Show.Sshow c) => a -> a -> (a -> a -> a) ->
                                   (a -> a -> a) ->
                                     (a -> a) ->
                                       (a -> a -> Bool) ->
 (b -> Nat.Nat -> (a, [a])) ->
   (Term.Term b c, Term.Term b c) -> Eithera.Eithera [[Char]] ();
check_polo_nsI ze on pl ti mz ge pia (s, t) =
  let {
    left = PolyOrder.pleftI ze on pl ti mz pia s;
    right = PolyOrder.prightI ze on pl ti mz pia t;
  } in ErrorMonad.catcha (Polynomial.check_lpoly_nsI ze on ge left right)
         (\ x ->
           ErrorMonad.errora
             (List.append
                (List.append
                  (List.append
                    ['c', 'o', 'u', 'l', 'd', ' ', 'n', 'o', 't', ' ', 'e', 'n',
                      's', 'u', 'r', 'e', ' ']
                    (Show.sshow_list x))
                  [' ', '>', '=', ' '])
                (Term.sshow_term t)
               : x));

get_comp_times ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> a -> a;
get_comp_times (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) = ti;

to_lpoly_inter ::
  forall a b.
    (Eq b) => a -> [((b, Nat.Nat), (a, [a]))] -> b -> Nat.Nat -> (a, [a]);
to_lpoly_inter on i f n =
  (case Util.lookupa (f, n) i of {
    Nothing -> (on, List.replicatea n on);
    Just cas -> cas;
  });

get_comp_description ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> [Char];
get_comp_description (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) =
  de;

create_lpoly_repr ::
  forall a b.
    (Eq a, Show.Sshow a, Eq b,
      Show.Sshow b) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> [((b, Nat.Nat), (a, [a]))] -> [[Char]];
create_lpoly_repr c i =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in List.append
         [List.append
            ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'i', 'n',
              't', 'e', 'r', 'p', 'r', 'e', 't', 'r', 'a', 't', 'i', 'o', 'n',
              ' ', 'o', 'v', 'e', 'r', ' ']
            (PolyOrder.get_comp_description c)]
         (List.mapa
           (\ (a @ (f, n)) ->
             let {
               t = Term.Fun f
                     (List.mapa Term.Var
                       (Show.fresh_strings ['x', '_'] Nat.one_nat n []));
             } in List.append
                    (List.append
                      (List.append ['P', 'o', 'l', '('] (Term.sshow_term t))
                      [')', ' ', '=', ' '])
                    (Polynomial.show_lpoly (PolyOrder.get_comp_0 c)
                      (PolyOrder.get_comp_1 c)
                      (PolyOrder.pleftI (PolyOrder.get_comp_0 c)
                        (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
                        (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
                        pia t)))
           (List.remdups (List.mapa fst i)));

check_poly_monoI ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => a -> (a -> a -> Bool) ->
                              (a -> Bool) ->
                                [((b, Nat.Nat), (a, [a]))] ->
                                  Eithera.Eithera [[Char]] ();
check_poly_monoI ze ge cm =
  (\ xs ->
    ErrorMonad.catcha
      (ErrorMonad.checkAllMI
        (\ (a @ (aa, b)) ->
          let {
            (f, n) = aa;
          } in (\ (ab @ (c, cs)) ->
                 ErrorMonad.catcha
                   (ErrorMonad.bind
                     (ErrorMonad.bind
                       (ErrorMonad.checkB (ge c ze)
                         [List.append
                            (List.append
                              (List.append
                                ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ',
                                  'p', 'a', 'r', 't', ' ']
                                (Show.sshow c))
                              [' ', 'm', 'u', 's', 't', ' ', 'b', 'e', ' ', 'a',
                                't', ' ', 'l', 'e', 'a', 's', 't', ' '])
                            (Show.sshow ze)])
                       (\ x ->
                         ErrorMonad.checkB
                           (Nat.less_eq_nat n (List.size_list cs))
                           [['t', 'h', 'e', ' ', 'l', 'a', 's', 't', ' ', 'a',
                              'r', 'g', 'u', 'm', 'e', 'n', 't', ' ', 'i', 's',
                              ' ', 'i', 'g', 'n', 'o', 'r', 'e', 'd']]))
                     (\ x ->
                       ErrorMonad.catcha
                         (ErrorMonad.checkAllMI
                           (\ d ->
                             ErrorMonad.checkB (cm d)
                               [List.append
                                  (List.append
                                    ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i',
                                      'e', 'n', 't', ' ']
                                    (Show.sshow d))
                                  [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                    'l', 'l', 'o', 'w', 'e', 'd']])
                           cs)
                         (\ xa -> ErrorMonad.errora (snd xa))))
                   (\ x ->
                     ErrorMonad.errora
                       (List.append
                          (List.append
                            (List.append
                              ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                                't', 'h', ' ', 'm', 'o', 'n', 'o', 't', 'o',
                                'n', 'i', 'c', 'i', 't', 'y', ' ', 'd', 'u',
                                'e', ' ', 't', 'o', ' ', 'i', 'n', 't', 'e',
                                'r', 'p', 'r', 'e', 't', 'a', 't', 'i', 'o',
                                'n', ' ', 'o', 'f', ' ']
                              (Show.sshow f))
                            ['/'])
                          (Show.sshow_nat n)
                         : x)))
            b)
        xs)
      (\ x -> ErrorMonad.errora (snd x)));

get_comp_wf_elem ::
  forall a.
    (a -> Bool,
      (a, (a, (a -> a -> a,
                (a -> a -> a,
                  (a -> a,
                    (a -> a -> Bool, (a -> a -> Bool, (Bool, [Char])))))))))
      -> a -> Bool;
get_comp_wf_elem (wfe, (ze, (on, (pl, (ti, (mz, (ge, (gt, (mo, de))))))))) =
  wfe;

check_lpoly_coeffs ::
  forall a b.
    (Show.Sshow a,
      Show.Sshow b) => (a -> Bool) ->
                         (a -> Bool) ->
                           [((b, Nat.Nat), (a, [a]))] ->
                             Eithera.Eithera [[Char]] ();
check_lpoly_coeffs wfe ch i =
  ErrorMonad.catcha
    (ErrorMonad.checkAllMI
      (\ (a @ (aa, b)) ->
        let {
          (f, n) = aa;
        } in (\ (ab @ (c, cs)) ->
               ErrorMonad.catcha
                 (ErrorMonad.bind
                   (ErrorMonad.checkB (wfe c)
                     [List.append
                        (List.append
                          ['c', 'o', 'n', 's', 't', 'a', 'n', 't', ' ', 'p',
                            'a', 'r', 't', ' ']
                          (Show.sshow c))
                        [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'w', 'e', 'l',
                          'l', '-', 'f', 'o', 'r', 'm', 'e', 'd']])
                   (\ x ->
                     ErrorMonad.catcha
                       (ErrorMonad.checkAllMI
                         (\ ac ->
                           ErrorMonad.checkB (ch ac && wfe ac)
                             [List.append
                                (List.append
                                  ['c', 'o', 'e', 'f', 'f', 'i', 'c', 'i', 'e',
                                    'n', 't', ' ']
                                  (Show.sshow ac))
                                [' ', 'i', 's', ' ', 'n', 'o', 't', ' ', 'a',
                                  'l', 'l', 'o', 'w', 'e', 'd']])
                         cs)
                       (\ xa -> ErrorMonad.errora (snd xa))))
                 (\ x ->
                   ErrorMonad.errora
                     (List.append
                        (List.append
                          (List.append
                            ['p', 'r', 'o', 'b', 'l', 'e', 'm', ' ', 'w', 'i',
                              't', 'h', ' ', 'i', 'n', 't', 'e', 'r', 'p', 'r',
                              'e', 't', 'a', 't', 'i', 'o', 'n', ' ', 'o', 'f',
                              ' ']
                            (Show.sshow f))
                          ['/'])
                        (Show.sshow_nat n)
                       : x)))
          b)
      i)
    (\ x -> ErrorMonad.errora (snd x));

create_rule_removal_proc_comp ::
  forall a b c.
    (Eq a, Show.Sshow a, Eq b, Show.Sshow b, Eq c,
      Show.Sshow c) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> (a -> Bool) ->
                              [((b, Nat.Nat), (a, [a]))] ->
                                [(Term.Term b c, Term.Term b c)] ->
                                  [(Term.Term b c, Term.Term b c)] ->
                                    Eithera.Eithera [[Char]] ();
create_rule_removal_proc_comp c cm i r rR =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in ErrorMonad.bind
         (PolyOrder.check_lpoly_coeffs (PolyOrder.get_comp_wf_elem c)
           (\ x -> PolyOrder.get_comp_ge c x (PolyOrder.get_comp_0 c)) i)
         (\ x ->
           RedPair.checkRuleRemovalProc
             (PolyOrder.check_poly_monoI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_ge c) cm i)
             (PolyOrder.check_polo_sI (PolyOrder.get_comp_mono c)
               (PolyOrder.get_comp_0 c) (PolyOrder.get_comp_1 c)
               (PolyOrder.get_comp_plus c) (PolyOrder.get_comp_times c)
               (PolyOrder.get_comp_max0 c) (PolyOrder.get_comp_ge c)
               (PolyOrder.get_comp_gt c) pia)
             (PolyOrder.check_polo_nsI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
               (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
               (PolyOrder.get_comp_ge c) pia)
             (List.append
               (List.append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (PolyOrder.get_comp_description c))
               [')'])
             (PolyOrder.create_lpoly_repr c i) r rR);

create_mono_redpair_ur_proc_comp ::
  forall a b c.
    (Eq a, Show.Sshow a, Eq b, Show.Sshow b, Eq c,
      Show.Sshow c) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> (a -> Bool) ->
                              [((b, Nat.Nat), (a, [a]))] ->
                                [(Term.Term b c, Term.Term b c)] ->
                                  [(Term.Term b c, Term.Term b c)] ->
                                    [(Term.Term b c, Term.Term b c)] ->
                                      Maybe (b ->
      [(Term.Term b c, Term.Term b c)])
-> [(Term.Term b c, Term.Term b c)] ->
     [(Term.Term b c, Term.Term b c)] -> Eithera.Eithera [[Char]] ();
create_mono_redpair_ur_proc_comp c cm i p rP r rm rR ur =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in ErrorMonad.bind
         (PolyOrder.check_lpoly_coeffs (PolyOrder.get_comp_wf_elem c)
           (\ x -> PolyOrder.get_comp_ge c x (PolyOrder.get_comp_0 c)) i)
         (\ x ->
           UsableRules.checkMonoRedPairUrProc
             (PolyOrder.check_poly_monoI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_ge c) cm i)
             (PolyOrder.check_polo_sI (PolyOrder.get_comp_mono c)
               (PolyOrder.get_comp_0 c) (PolyOrder.get_comp_1 c)
               (PolyOrder.get_comp_plus c) (PolyOrder.get_comp_times c)
               (PolyOrder.get_comp_max0 c) (PolyOrder.get_comp_ge c)
               (PolyOrder.get_comp_gt c) pia)
             (PolyOrder.check_polo_nsI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
               (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
               (PolyOrder.get_comp_ge c) pia)
             (List.append
               (List.append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (PolyOrder.get_comp_description c))
               [')'])
             (PolyOrder.create_lpoly_repr c i) p rP r rm rR ur);

create_mono_redpair_proc_comp ::
  forall a b c.
    (Eq a, Show.Sshow a, Eq b, Show.Sshow b, Eq c,
      Show.Sshow c) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> (a -> Bool) ->
                              [((b, Nat.Nat), (a, [a]))] ->
                                [(Term.Term b c, Term.Term b c)] ->
                                  [(Term.Term b c, Term.Term b c)] ->
                                    [(Term.Term b c, Term.Term b c)] ->
                                      [(Term.Term b c, Term.Term b c)] ->
Eithera.Eithera [[Char]] ();
create_mono_redpair_proc_comp c cm i p rP r rR =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in ErrorMonad.bind
         (PolyOrder.check_lpoly_coeffs (PolyOrder.get_comp_wf_elem c)
           (\ x -> PolyOrder.get_comp_ge c x (PolyOrder.get_comp_0 c)) i)
         (\ x ->
           RedPair.checkMonoRedPairProc
             (PolyOrder.check_poly_monoI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_ge c) cm i)
             (PolyOrder.check_polo_sI (PolyOrder.get_comp_mono c)
               (PolyOrder.get_comp_0 c) (PolyOrder.get_comp_1 c)
               (PolyOrder.get_comp_plus c) (PolyOrder.get_comp_times c)
               (PolyOrder.get_comp_max0 c) (PolyOrder.get_comp_ge c)
               (PolyOrder.get_comp_gt c) pia)
             (PolyOrder.check_polo_nsI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
               (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
               (PolyOrder.get_comp_ge c) pia)
             (List.append
               (List.append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (PolyOrder.get_comp_description c))
               [')'])
             (PolyOrder.create_lpoly_repr c i) p rP r rR);

create_redpair_ur_af_proc_comp ::
  forall a b c.
    (Eq a, Show.Sshow a, Eq b, Show.Sshow b, Eq c,
      Show.Sshow c) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> [((b, Nat.Nat), (a, [a]))] ->
                              [(Term.Term b c, Term.Term b c)] ->
                                [(Term.Term b c, Term.Term b c)] ->
                                  [(Term.Term b c, Term.Term b c)] ->
                                    Maybe (b ->
    [(Term.Term b c, Term.Term b c)])
                                      -> [(Term.Term b c, Term.Term b c)] ->
   Eithera.Eithera [[Char]] ();
create_redpair_ur_af_proc_comp c i p rP r rm ur =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in ErrorMonad.bind
         (PolyOrder.check_lpoly_coeffs (PolyOrder.get_comp_wf_elem c)
           (\ x -> PolyOrder.get_comp_ge c x (PolyOrder.get_comp_0 c)) i)
         (\ x ->
           UsableRules.checkRedPairUrAfProc
             (PolyOrder.check_polo_sI (PolyOrder.get_comp_mono c)
               (PolyOrder.get_comp_0 c) (PolyOrder.get_comp_1 c)
               (PolyOrder.get_comp_plus c) (PolyOrder.get_comp_times c)
               (PolyOrder.get_comp_max0 c) (PolyOrder.get_comp_ge c)
               (PolyOrder.get_comp_gt c) pia)
             (PolyOrder.check_polo_nsI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
               (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
               (PolyOrder.get_comp_ge c) pia)
             (List.append
               (List.append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (PolyOrder.get_comp_description c))
               [')'])
             (PolyOrder.create_lpoly_repr c i) p rP r rm ur
             (PolyOrder.create_afI (PolyOrder.get_comp_0 c) i));

create_redpair_proc_comp ::
  forall a b c.
    (Eq a, Show.Sshow a, Eq b, Show.Sshow b, Eq c,
      Show.Sshow c) => (a -> Bool,
                         (a, (a, (a -> a -> a,
                                   (a -> a -> a,
                                     (a -> a,
                                       (a -> a -> Bool,
 (a -> a -> Bool, (Bool, [Char])))))))))
                         -> [((b, Nat.Nat), (a, [a]))] ->
                              [(Term.Term b c, Term.Term b c)] ->
                                [(Term.Term b c, Term.Term b c)] ->
                                  [(Term.Term b c, Term.Term b c)] ->
                                    Eithera.Eithera [[Char]] ();
create_redpair_proc_comp c i p rP r =
  let {
    pia = PolyOrder.to_lpoly_inter (PolyOrder.get_comp_1 c) i;
  } in ErrorMonad.bind
         (PolyOrder.check_lpoly_coeffs (PolyOrder.get_comp_wf_elem c)
           (\ x -> PolyOrder.get_comp_ge c x (PolyOrder.get_comp_0 c)) i)
         (\ x ->
           RedPair.checkRedPairProc
             (PolyOrder.check_polo_sI (PolyOrder.get_comp_mono c)
               (PolyOrder.get_comp_0 c) (PolyOrder.get_comp_1 c)
               (PolyOrder.get_comp_plus c) (PolyOrder.get_comp_times c)
               (PolyOrder.get_comp_max0 c) (PolyOrder.get_comp_ge c)
               (PolyOrder.get_comp_gt c) pia)
             (PolyOrder.check_polo_nsI (PolyOrder.get_comp_0 c)
               (PolyOrder.get_comp_1 c) (PolyOrder.get_comp_plus c)
               (PolyOrder.get_comp_times c) (PolyOrder.get_comp_max0 c)
               (PolyOrder.get_comp_ge c) pia)
             (List.append
               (List.append
                 ['p', 'o', 'l', 'y', 'n', 'o', 'm', 'i', 'a', 'l', ' ', 'o',
                   'r', 'd', 'e', 'r', ' ', '(']
                 (PolyOrder.get_comp_description c))
               [')'])
             (PolyOrder.create_lpoly_repr c i) p rP r);

}
